<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Notifications\Notifiable;
use OwenIt\Auditing\Auditable as AuditableTrait;
use OwenIt\Auditing\Contracts\Auditable;

class EmployeeLeave extends Model implements Auditable
{
    use HasFactory, SoftDeletes, AuditableTrait, Notifiable;

    /**
     * The attributes that are NOT mass assignable.
     *
     */
    protected $guarded = [
        'deleted_at',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'created_at' => 'datetime',
        'updated_at' => 'datetime',
        'deleted_at' => 'datetime',
    ];
    
    public function employee(): BelongsTo
    {
        return $this->belongsTo(Employee::class, 'employee_id', 'employee_id');
    }

    public function leave_type(): BelongsTo
    {
        return $this->belongsTo(LeaveType::class, 'leave_id');
    }

    public function recommending(): HasMany
    {
        return $this->hasMany(Employee::class, 'employee_id', 'recommending_id');
    }

    public function approving(): HasMany
    {
        return $this->hasMany(Employee::class, 'employee_id', 'approver_id');
    }

    public function reason(): BelongsTo
    {
        return $this->belongsTo(LeaveReason::class, 'leave_reason_id');
    }

}
